#include "HelloWorldScene.h"

#include "editor-support/cocosbuilder/CocosBuilder.h"
#include "MainScene.h"

USING_NS_CC;
using namespace cocosbuilder;

Scene* HelloWorld::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();
    
    // 'layer' is an autorelease object
    auto layer = HelloWorld::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
    if (!Layer::init()) {
        return false;
    }
    
    auto nodeLoaderLibrary = NodeLoaderLibrary::getInstance();
    nodeLoaderLibrary->registerNodeLoader("MainScene", MainSceneLoader::loader());
    auto ccbReader = new CCBReader(nodeLoaderLibrary);
    ccbReader->autorelease();
    
    auto node = ccbReader->readNodeGraphFromFile("MainScene.ccbi");
    node->setPosition(Vec2(0, 0));
    this->addChild(node);
    
    return true;
}
