#ifndef __MAIN_SCENE_H_
#define __MAIN_SCENE_H_

#include "cocos2d.h"
#include "editor-support/cocosbuilder/CocosBuilder.h"

class MainScene : public cocos2d::Layer, public cocosbuilder::CCBSelectorResolver, public cocosbuilder::CCBMemberVariableAssigner
{
public:
    // MainSceneの作成メソッド
    CREATE_FUNC(MainScene);
    virtual bool init();
    
    // CocosBuilderで作成したオブジェクトとの連携をするメソッド
    virtual bool onAssignCCBMemberVariable(cocos2d::Ref *pTarget, const char *pMemberVariableName, cocos2d::Node *pNode);
    virtual cocos2d::SEL_MenuHandler onResolveCCBCCMenuItemSelector(cocos2d::Ref *pTarget, const char *pSelectorName);
    virtual cocos2d::extension::Control::Handler onResolveCCBCCControlSelector(cocos2d::Ref *pTarget, const char *pSelectorName) {
        return nullptr; // 使用しませんが、オーバーライドする必要があります
    };
    
    // ボタンを押した際のコールバック
    void onPressButton(cocos2d::Ref *sender);
    
protected:
    // CocosBuilderで作成したLabelと紐付けるための変数
    cocos2d::Label *_label;
};

// CocosBuilderファイルと連携するためのローダ
class MainSceneLoader : public cocosbuilder::LayerLoader
{
public:
    CCB_STATIC_NEW_AUTORELEASE_OBJECT_METHOD(MainSceneLoader, loader);
protected:
    CCB_VIRTUAL_NEW_AUTORELEASE_CREATECCNODE_METHOD(MainScene);
};

#endif // __MAIN_SCENE_H_
