#include "HelloWorldScene.h"

USING_NS_CC;

Scene* HelloWorld::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();
    
    // 'layer' is an autorelease object
    auto layer = HelloWorld::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
  //////////////////////////////
  // 1. super init first
  if ( !Layer::init() )
  {
      return false;
  }
  
  Size visibleSize = Director::getInstance()->getVisibleSize();
  Vec2 origin = Director::getInstance()->getVisibleOrigin();

  auto map = TMXTiledMap::create("tilemap.tmx");
  map->setAnchorPoint(Vec2(0,0));
  map->setPosition(Point(0,0));
  this->addChild(map);
  
  auto group = map->getObjectGroup("objects");
  auto object = group->getObject("rect");
  auto objects = group->getObjects();

  log("object Property : %s",object["property"].asString().c_str());
  log("object x : %f",object["x"].asFloat());
  log("object y : %f",object["y"].asFloat());
  
  for (auto object : objects) {
    
    ValueMap objectInfo = object.asValueMap();
    if (objectInfo.find("property") == objectInfo.end()) {
      continue;
    }

    log("object Name : %s", objectInfo.at("name").asString().c_str());
    log("object Property : %s", objectInfo.at("property").asString().c_str());
    log("object x : %f", objectInfo.at("x").asFloat());
    log("object y : %f", objectInfo.at("y").asFloat());
    
  }
  
  
  auto tileLayer = map->getLayer("main");
  auto gid = tileLayer->getTileGIDAt(Vec2(1,8));
  auto properties = map->getPropertiesForGID(gid).asValueMap();
  log("property = %s",properties["property"].asString().c_str());
  
  
    return true;
}
